#!/bin/bash
jet='/mnt/'
#Jet相關參數取得
sIFS=$IFS
declare -A param
while IFS='=' read -r -d '&' key value; do
        [[ -z "$key" ]] && continue
        param["$key"]=$value
done <<<$(cat)"&"
IFS=$sIFS
#-----------------------------------

if [ ! -e /home/${param[account]} ]; then

        #還原snap編號
        snapid=$(jetapi backup -F getQueueItem -D _id="${param[queue_id]}" | grep 'snap_id' | cut -d : -f 2 | sed s/[[:space:]]//g)
        #path
        path=$(jetapi backup -F listBackups -D "type=127&accounts[]=${param[account]}" | grep -A5 ${snapid} | grep 'path:' | cut -d : -f 2 | sed s/[[:space:]]//g)

        exec </tmp/${param[account]}.list

        while read line; do
                mv ${line}public_html/ ${jet}${path}/homedir/
                mv ${line}mail/ ${jet}${path}/homedir/
        done

        exit

fi

#移除當前public_html,mail
rm -rf /home/${param[account]}/public_html
rm -rf /home/${param[account]}/mail

#導入路徑，轉移public_html,mail
exec </tmp/${param[account]}.list
while read line; do
        mv ${line}public_html/ /home/${param[account]}/
        mv ${line}mail/ /home/${param[account]}/
done

# 修正public_html目錄與檔案權限
find /home/${param[account]}/public_html -type d -exec chmod 755 {} \;
find /home/${param[account]}/public_html -type f | xargs -d$'\n' -r chmod 644
find /home/${param[account]}/public_html -name '*.cgi' -o -name '*.pl' -o -name '*.perl' | xargs -r chmod 755
chown -R ${param[account]}:${param[account]} /home/${param[account]}/public_html/
find /home/${param[account]}/public_html -name .htaccess -exec chown ${param[account]}.${param[account]} {} \;
chown ${param[account]}:nobody /home/${param[account]}/public_html
chmod 750 /home/${param[account]}/public_html

# 修正沒有放在 public_html 範圍內網站根目錄權限
for SUBDOMAIN in $(grep -i documentroot /var/cpanel/userdata/${param[account]}/* | grep -v '.cache\|_SSL' | awk '{print $2}' | grep -v public_html); do
        find $SUBDOMAIN -type d -exec chmod 755 {} \;
        find $SUBDOMAIN -type f | xargs -d$'\n' -r chmod 644
        find $SUBDOMAIN -name '*.cgi' -o -name '*.pl' -o -name '*.perl' | xargs -r chmod 755

        chown -R ${param[account]}:${param[account]} $SUBDOMAIN
        find $SUBDOMAIN -name .htaccess -exec chown ${param[account]}.${param[account]} {} \;
        chmod 750 $SUBDOMAIN
        chown ${param[account]}:nobody $SUBDOMAIN
done

# 修正放在 public_html 範圍內網站根目錄權限
for SUBDOMAIN in $(grep -i documentroot /var/cpanel/userdata/${param[account]}/* | grep -v '.cache\|_SSL' | awk '{print $2}' | grep public_html); do
        chmod 750 $SUBDOMAIN
        chown ${param[account]}:nobody $SUBDOMAIN
done

#修正mail權限
chown ${param[account]}:${param[account]} /home/${param[account]}/mail/
chown -R ${param[account]}:${param[account]} /home/${param[account]}/mail/


if [  -e /tmp/quota.list ]; then

        #手動確認帳號大小
        newquoto=$(quota -su ${param[account]} | tail -n1 | awk '{printf $3}' | sed 's/M//g')
        oldquoto=$(cat /tmp/quota.list |grep "${param[account]}" |awk -F , '{print $2}')

        if [[ ${newquoto} != ${oldquoto} ]];then

                echo ${param[account]} >> /root/check_account_quota_list

        fi

fi

#刪除list
rm -f /tmp/${param[account]}.list
